# Advent of Code 2021 solutions 

A set of 25 puzzle inputs and 50 puzzle solutions, two for each day. Most can
be solved in minutes.  The puzzles can be found
[here](https://adventofcode.com/2021/), although only the first one for each
day is visible until you solve it.

Most solutions output at most two lines, the answers to part 1 and 2; but some
provide more information in the form of e.g. graphics.

Run a solution by passing the puzzle input to the program:

```./one_first.awk <input1```

or

```./five.py -v <input5```

or

```
cd six
lein run <../input6
lein run 256 <../input6
```
